/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_sqrt.c,v 1.2 1997/09/25 18:23:07 ae59 Exp $ */
/*
$Log: t_sqrt.c,v $
 * Revision 1.2  1997/09/25  18:23:07  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:49  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_sqrt.c                              */
/*                                                              */
/*      Date            : 1991-11-13                            */
/*      1991-11-13 : flags saved and restored                   */
/*      1991-09-24 : do not include t_head.h                    */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-09-06 : reduce maximum line length                 */
/*      1991-08-05 : compare with 0                             */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_sqrt,sqrtee) */     /* siehe t_sqrt unten, */
                                    /* wegen Rundungsproblemen */
/* ------------------------------------------------------------ */

/*--------------------------------------------------------------*
 | Punkt Wurzel                                                 |
 *--------------------------------------------------------------*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int sqrtee (const ExtReal *arg, ExtReal *res)
#else
int sqrtee (arg, res)
const ExtReal  *arg;
      ExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int sqrtee (ExtReal *arg, ExtReal *res)
#else
int sqrtee (arg, res)
ExtReal  *arg;
ExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   int         rnd;        /* RundungsMode                      */
   int         ret;        /* Rueckgabe                         */
   int         check;      /* Rueckgabe von Makro ArgCheck      */


   /* --- pruefe Argument, evtl. Abbruch --- */
   ArgCheck1(Sqrt, arg, res);

   /* --- RundungsMode sichern, NEAR setzen --- */
   rnd  = getrndmode();
   setrndmode(NEAR);

   /* --- Wurzel --- */
   ret = _s_sqrt(arg, res);

   /* --- RundungsMode zuruecksetzen --- */
   setrndmode(rnd);
   return ret;
} /* sqrtee() */

/*--------------------------------------------------------------*/

#ifdef LINT_ARGS
a_real t_sqrt(a_real arg)
#else
a_real t_sqrt(arg)
a_real arg;
#endif
{
    int rnd, rc;
    a_real res;
    ExtReal a, r, rsucc, rpred, tmp;
    a_real lmin, rs, rp;

    E_SPUSH("t_sqrt")

    rnd = getrndmode();
    setrndmode(NEAR);
    longreal_to_extreal((LongReal *)&arg, &a);

    if ((rc = sqrtee(&a, &r))!=0
        || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
         ieee_abortr1(rc, &arg);

    /* Rundung nachpruefen */
    if (cmpee(&r, &Zero) != 0)
    {
       extreal_to_longreal(&LongRealMin, (LongReal *)&lmin);
      
       R_ASSIGN(rs,r_addu(res, lmin));
       R_ASSIGN(rp,r_subd(res, lmin));
       
       longreal_to_extreal((LongReal *)&res, &r);
       longreal_to_extreal((LongReal *)&rs,  &rsucc);
       longreal_to_extreal((LongReal *)&rp,  &rpred);
       setrndmode(DOWN);
       mulee(&r, &rpred, &tmp);
       if (cmpee(&tmp, &a) < 0)
       {
          mulee(&r, &rsucc, &tmp);
          if (cmpee(&a, &tmp) > 0)
             memcpy(&res, &rs, sizeof(res));
       }
       else
          memcpy(&res, &rp, sizeof(res));
    } 

    setrndmode(rnd);

    E_SPOPP("t_sqrt")
    return(res);
}
